package org.astakhova.data;

/**
 * Makes a description of a conditional node
 * @author Astakhova Julia A.
 */
public interface IConditionNode extends INode{
	/**
	 * Checks if a true branch arrow can be added to the node
	 * @return true if a true branch arrow
	 *  can be added to the node 
	 */
	public boolean canBindByTrueBranch();
	
	/**
	 * Checks if a false branch arrow can be added to the node
	 * @return true if a false branch arrow
	 *  can be added to the node 
	 */
	public boolean canBindByFalseBranch();
}
