package org.astakhova.test;

import org.astakhova.data.DiagramFactory;
import org.astakhova.data.IConditionNode;
import org.astakhova.data.IDiagram;
import org.astakhova.data.INode;
import org.astakhova.writer.FileWriter;
import java.io.FileReader;
import junit.framework.TestCase;

public class JTestWriter extends TestCase {
	public void testWriter1() {
		IDiagram d = DiagramFactory.newDiagram();
		INode n1 = d.createDataNode(150, 50);
		n1.setText("B");
		INode n4 = d.createDataNode(105, 200);
		n4.setText("DDD");
		INode n0 = d.createDataNode(200, 200);
		n0.setText("AAAAAAAAAA");
		d.createEndNode(150, 300);
		INode n5 = d.createCondNode(145, 120);
		n5.setText("F");
		d.createBeginNode(150, 10);
		checkWriting(d, "file1.bde", "test/writer/test1.txt");
	}
	
	public void testWriter2() {
		IDiagram d = DiagramFactory.newDiagram();
		checkWriting(d, "file2.bde", "test/writer/test2.txt");
	}
	
	public void testWriter3() {
		IDiagram d = DiagramFactory.newDiagram();
		
		INode n1 = d.createDataNode(150, 50);
		n1.setText("B");
		INode n4 = d.createDataNode(105, 200);
		n4.setText("DDD");
		INode n0 = d.createDataNode(200, 200);
		n0.setText("AAAAAAAAAA");
		d.createEndNode(150, 300);
		INode n5 = d.createCondNode(145, 120);
		n5.setText("F");
		d.createBeginNode(150, 10);
		
		d.createArrow(n4, n0);
		d.createArrow(d.getNode(150, 10), n1);
		d.createArrow(n1, n5);
		d.createArrow((IConditionNode) n5, n4, true);
		d.createArrow((IConditionNode)n5, n0, false);
		d.createArrow(n0, d.getNode(150, 300));
		
		checkWriting(d, "file3.bde", "test/writer/test3.txt");
	}
	
	public void testWriter4() {
		IDiagram d = DiagramFactory.newDiagram();
		INode n1 = d.createDataNode(150, 50);
		n1.setText(" now english");
		checkWriting(d, "file4.bde", "test/writer/test4.txt");
	}
	
	private void checkWriting(IDiagram d, String fileName, 
			String patternName) {
		try {
			FileWriter fw = new FileWriter(d);
			fw.write(patternName);
			fw.write(fileName);
			FileReader fr1 = new FileReader(fileName),
				fr2 = new FileReader(patternName);
			int a, b;
			while (((a = fr1.read()) >= 0) && ((b = fr2.read()) >= 0))
				assertEquals(a, b);
		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}
	}
}
