package org.astakhova.view;

import javax.swing.*;
import java.awt.*;

/**
 * Makes a description of block's text field 
 * @author Astakhova Julia A.
 */
public class BlockLabel extends JTextField {
	static final long serialVersionUID = 1;
	private Color myColor;
	private int myX;
	private int myY;
	private Font myFont;
	
	/**
	 * Creates a new block label containing the string
	 * @param s label string
	 */
	public BlockLabel(String s) {
		super(s);
		setEditable(false);
	}
	
	public void paintComponent(Graphics g) {
		setLocation(myX, myY);
		g.setFont(myFont);
		g.setColor(myColor);
		
		super.paintComponent(g);
	}
	
	/**
	 * Sets a color
	 * @param c color for the label
	 */
	public void setColor(Color c) {
		myColor = c;
	}
	
	public void setX(int x) {
		myX = x;
	}
	
	public void setY(int y) {
		myY = y;
	}
	
	public void setFont(Font f) {
		myFont = f;
	}
}
