package org.astakhova.view;

import java.awt.datatransfer.*;
import java.awt.image.*;
import java.io.IOException;
import javax.swing.*;

/**
 * Makes a description of the image to copy to clipboard
 * @author Astakhova Julia A.
 */
public class ClipboardImage implements ClipboardOwner {
	private static DataFlavor myFlavor = java.awt.datatransfer.DataFlavor.imageFlavor;
	private BufferedImage myImage;
	
	public void lostOwnership(Clipboard cb, Transferable trans) {
		  System.out.println("Lost ownership of system clipboard");
	}
	
	/**
	 * Copies the image to clipboard
	 * @param bi image to copy
	 * @param o clipboard owner
	 */
	public void copyToClipboard(BufferedImage bi, JFrame o)	{
		  myImage = bi;
		  Clipboard clipboard;
		  ImageSelection selec;
		  clipboard = o.getToolkit().getSystemClipboard();
		  selec = new ImageSelection();
		  clipboard.setContents(selec, this);
	}

	  class ImageSelection implements Transferable {
		  public synchronized DataFlavor[] getTransferDataFlavors() {
			  return new DataFlavor[]{myFlavor};
		  }
		 
		  public boolean isDataFlavorSupported(DataFlavor flavor) {
		      return myFlavor.equals(flavor);
		  }
		 
		  public synchronized Object getTransferData(DataFlavor flavor)
		  	throws UnsupportedFlavorException, IOException {
			  if (!myFlavor.equals(flavor))
				  throw new UnsupportedFlavorException(flavor);
			  return (myImage);
		  }
	  }
}
