package org.astakhova.view;

import java.awt.Graphics;
import java.awt.Point;

import org.astakhova.data.INode;

/**
 * Makes a description of a conditional line
 * @author Astakhova Julia A.
 */
public class ConditionLine extends Line {
	static final long serialVersionUID = 1;
	private boolean myPart;
	
	/**
	 * Sets the source node for the line and the branch it's connected by
	 * @param n conditional node - source
	 * @param b branch
	 */
	public void setNode(INode n, boolean b) {
		super.setNode(n);
		myPart = b;
	}
	
	public void paintComponent(Graphics g) {
		int srcLeft = getNode().getX();
		int srcTop = getNode().getY();
		int srcRight = srcLeft + getNode().getWidth();
		int srcBottom = srcTop + getNode().getHeight();
		
		g.setColor(getColor());
		Point b = new Point(), e = new Point();
		b.y = e.y = (srcBottom - srcTop) / 2 + srcTop;
		if (myPart) {
			b.x = srcLeft;
			e.x = b.x - 20;
			g.drawString("Yes", e.x + 3, e.y - 4);
		} else {
			b.x = srcRight;
			e.x = b.x + 20;
			g.drawString("No", b.x, b.y - 4);
		}
		g.drawLine(b.x, b.y, e.x, e.y);
		
		setSourcePoint(e.x, e.y);
		super.paintComponent(g);
	}
}
