package org.astakhova.view;

import org.astakhova.data.*;
import java.awt.*;

/**
 * Makes a description of links
 * @author Astakhova Julia A.
 */
public class Link extends AbstractLink {
	static final long serialVersionUID = 1;
	
	/**
	 * Creates a new link according to the arrow it present
	 * @param a arrow
	 */
	public Link(IArrow a) {
		super(a);
	}
	
	public void paintComponent(Graphics g) {		
		int srcLeft = getArrow().getSource().getX();
		int srcTop = getArrow().getSource().getY();
		int srcRight = srcLeft + getArrow().getSource().getWidth();
		int srcBottom = srcTop + getArrow().getSource().getHeight();
		 
		int tgtLeft = getArrow().getDest().getX();
		int tgtTop = getArrow().getDest().getY();
		int tgtRight = tgtLeft + getArrow().getDest().getWidth();
		int tgtBottom = tgtTop + getArrow().getDest().getHeight();
		
		setParameters(srcLeft, srcRight, srcTop, srcBottom,
				tgtLeft, tgtRight, tgtTop, tgtBottom);
		super.paintComponent(g);
	}
}
